"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MerryGoRound = void 0;

var _react = _interopRequireWildcard(require("react"));

require("./style.css");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var MerryGoRound = function MerryGoRound(props) {
  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      items = _useState2[0],
      setItems = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = _slicedToArray(_useState3, 2),
      position = _useState4[0],
      setPosition = _useState4[1];

  var _useState5 = (0, _react.useState)(0),
      _useState6 = _slicedToArray(_useState5, 2),
      firstItemIndex = _useState6[0],
      seFirstItemIndex = _useState6[1];

  (0, _react.useEffect)(function () {
    var items = props.items;
    setItems(items);
  }, []);

  var navigate = function navigate(direction) {
    var nextFirstItemIndex = direction + firstItemIndex;
    var nextLastItemIndex = nextFirstItemIndex + 3;
    var nextItemExists = items[nextLastItemIndex];

    if (direction === 1 && nextItemExists) {
      setPosition(position - 100 / 4);
      seFirstItemIndex(nextFirstItemIndex);
    }

    if (direction === -1) {
      if (!items[nextFirstItemIndex]) {
        seFirstItemIndex(nextFirstItemIndex);
        seFirstItemIndex(0);
        setPosition(0);
      } else {
        seFirstItemIndex(nextFirstItemIndex);
        setPosition(position + 100 / 4);
      }
    }
  };

  var next = function next() {
    return navigate(1);
  };

  var prev = function prev() {
    return navigate(-1);
  };

  return _react.default.createElement("div", null, _react.default.createElement("h1", null, firstItemIndex), _react.default.createElement("div", {
    className: "panel"
  }, _react.default.createElement("button", {
    style: {
      left: '-1.5rem'
    },
    onClick: prev
  }, "<"), _react.default.createElement("button", {
    style: {
      right: '-1.5rem'
    },
    onClick: next
  }, ">"), _react.default.createElement("div", {
    className: "frame"
  }, _react.default.createElement("div", {
    className: "window",
    style: {
      left: "".concat(position, "%"),
      transition: 'left 1s'
    }
  }, items.map(function (item) {
    return _react.default.createElement("div", null, item);
  })))));
};

exports.MerryGoRound = MerryGoRound;